#version 150

#moj_import <fog.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in float vertexDistance;
in vec4 vertexColor;
in vec4 lightMapColor;
in vec4 overlayColor;
in vec2 texCoord0;
in vec4 normal;

out vec4 fragColor;

void emissiveColor(vec4 texColor, float r, float g, float b) {
    if (texColor.rgb == vec3(r / 255.0f, g / 255.0f, b / 255.0f)) {	
		fragColor.rgb = texColor.rgb;
	}
}

void main() {
	vec4 texColor = texture(Sampler0, texCoord0);

    vec4 color = texColor;
    if (color.a < 0.1) {
        discard;
    }
    color *= vertexColor * ColorModulator;
    color.rgb = mix(overlayColor.rgb, color.rgb, overlayColor.a);
    color *= lightMapColor;
    fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
	
    emissiveColor(texColor, 66, 255, 245);
	emissiveColor(texColor, 0, 255, 255);
	emissiveColor(texColor, 26, 225, 225);
	emissiveColor(texColor, 17, 172, 163);
	emissiveColor(texColor, 180, 255, 255);
	emissiveColor(texColor, 0, 255, 241);
	emissiveColor(texColor, 42, 227, 208);
	emissiveColor(texColor, 21, 169, 169);
	emissiveColor(texColor, 14, 196, 196);
	emissiveColor(texColor, 47, 227, 208);
	emissiveColor(texColor, 23, 150, 143);
	emissiveColor(texColor, 17, 113, 108);
	emissiveColor(texColor, 18, 141, 134);
	emissiveColor(texColor, 0, 221, 246);
	emissiveColor(texColor, 0, 203, 226);
	emissiveColor(texColor, 0, 186, 208);	
	emissiveColor(texColor, 21, 120, 108);
}
